%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object oriented design (OOD) principles}
    \begin{itemize}[<+->]
        \item Object oriented programming allows for very structured code.
        \item Important to get the structure right
        \item Common design principles:
        \begin{description}
            \item[DRY] don't repeat yourself\\
            avoid code duplication
            \item[KISS] keep it simple, stupid\\
            don't make it more complicated than necessary
            \item[SOLID] five more detailed rules, see next slide.
        \end{description} 
    \end{itemize}
\end{frame}
    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{OOD: SOLID}
    \small
        \begin{itemize}[<+->]
            \item {\bf {\color{red} S}ingle responsibility principle (SRP):} \\
            {\footnotesize A class should have only one responsibility.\\
            This makes the code easier to understand and maintain.}
            \item {\bf {\color{red} O}pen-closed principle (OCP):}\\
            {\footnotesize A class should be open for extension but closed for modification. \\
            New features should be added to the class without modifying the existing code.}
            \item {\bf {\color{red} L}iskov substitution principle (LSP):}\\
            {\footnotesize Objects of a subclass should be substitutable for objects of their superclass. \\
            A subclass should be able to do everything that its superclass can do.}
            \item {\bf {\color{red} I}nterface segregation principle (ISP):}\\
            {\footnotesize A client should not be forced to depend on methods that it does not use. \\
            A interfaces should be split into smaller, more specific interfaces.}
            \item {\bf {\color{red} D}ependency inversion principle (DIP):}\\
            {\footnotesize High-level modules should not depend on low-level modules. Instead, both should depend on abstractions. \\ 
            The code should depend on interfaces, not concrete implementations.}
        \end{itemize}
    
\end{frame}
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    \begin{frame}[fragile] \frametitle{OOD: design patterns}
        For many situations, clear patterns have emerged.
        \vspace*{1cm}
        \begin{columns}
            \begin{column}{0.6\textwidth}
                \begin{itemize}
                    \item \href{https://refactoring.guru/}{https://refactoring.guru:}\\
                    Overview of design patterns
                    \vspace*{1cm}
                    \item Scientific Software Design:\\
                    The object oriented way\\
                    (There is a copy in my office)\\
    
                \end{itemize}
            \end{column}
            \begin{column}{0.4\textwidth}
                \includegraphics[scale=0.4]{img/scientific_software_design.jpg}
                
            \end{column}
        \end{columns}
    
    \end{frame}
    